=== debian/changelog ===
pike8.0 (8.0.28-3) unstable; urgency=medium

  * pike8.0-core.postrm, pike8.0-core.lintian-overrides: Change missed
    instances of old version number to 8.0 (Closes: #793676).

 -- Magnus Holmgren <holmgren@debian.org>  Mon, 03 Aug 2015 18:52:52 +0200

pike8.0 (8.0.28-2) unstable; urgency=low

  * Upload to unstable.

 -- Magnus Holmgren <holmgren@debian.org>  Mon, 22 Jun 2015 19:57:20 +0200

pike8.0 (8.0.28-1) experimental; urgency=low

  * New major upstream version.
    - Drops compatibility support for versions prior to 7.6.
  * Update debian/watch to look for 8.0 tarballs in
    http://pike.lysator.liu.se/download/pub/pike/all/
  * Bump Standards-Version to 3.9.6.
  * Drop pcre_info_obsolete.patch; fixed upstream.
  * Disable the deprecated Pike security system.
  * Drop debian/source/lintian-overrides; upstream has dropped the bundles
    system which brought the old autotools helper files.
  * Build with libgtksourceview2.0-dev.

 -- Magnus Holmgren <holmgren@debian.org>  Sun, 15 Mar 2015 21:28:40 +0100

pike7.8 (7.8.866-2) unstable; urgency=low

  * Upload to unstable.
  * Correct watch URL.
  * Correct Vcs-Svn URI again; should use anonscm.debian.org.
  * bad_size_t_redef.patch: Fix undefined behaviour/buffer overruns in
    module _Image_JPEG on 64-bit architectures due to broken redefinition
    of size_t (Closes: #750430).
  * Use dh_installdocs --link-doc to create doc symlinks in module
    packages.
  * Replace GPL and LGPL license texts used by Tools.Legal.License with
    symlinks to corresponding files in /usr/share/common-licenses.
    Override remaining Lintian warnings about GPL.pmod and LGPL.pmod,
    which do not include the license texts themselves.

 -- Magnus Holmgren <holmgren@debian.org>  Sat, 02 Aug 2014 21:47:30 +0200

pike7.8 (7.8.866-1) experimental; urgency=low

  * New upstream beta version.
  * debian/control: Correct Vcs-Svn URI.

 -- Magnus Holmgren <holmgren@debian.org>  Sat, 07 Jun 2014 12:59:38 +0200

pike7.8 (7.8.852-1) experimental; urgency=low

  * New upstream beta version.
  * Drop reg_enum_conflict.patch and nettle_crypt_md5_buffer_size.patch;
    incorporated upstream. Refresh remaining patches.
  * Bump Standards-Version to 3.9.5.

 -- Magnus Holmgren <holmgren@debian.org>  Tue, 22 Apr 2014 19:38:46 +0200

pike7.8 (7.8.700-7) unstable; urgency=low

  * Correct the Replaces and Breaks declarations related to moving
    Tools.PV (Closes: #711593).
  * Also move compatibility Image module to pike7.8-image.
  * Modify package descriptions noting what modules are in each package
    and that the Postgres module is deprecated.
  * Update Vcs-Browser URL.
  * Actually apply undefined_htons.patch.

 -- Magnus Holmgren <holmgren@debian.org>  Sat, 08 Jun 2013 20:15:11 +0200

pike7.8 (7.8.700-6) unstable; urgency=low

  * hurd.patch: Add mach/message.h to one more place in src/configure and 
    add HAVE_MACH_MESSAGE_H to src/machine.h.in.
  * nettle_crypt_md5_buffer_size.patch (new): Nette.MD5: passwd array was
    too small.
  * pcre_info_obsolete.patch (new): Stop using the long-obsolete
    pcre_info(), which was just recently removed from the headers but
    remains in the library.
  * undefined_htons.patch (mew): Include the necessary header file
    declaring htons() in Protocols.DNS_SD.

 -- Magnus Holmgren <holmgren@debian.org>  Sat, 08 Jun 2013 01:56:51 +0200

pike7.8 (7.8.700-5) unstable; urgency=low

  * Build-depend on libtiff-dev rather than libtiff4-dev (Closes: #708365).
  * Move Tools.PV from -core to -gtk and make -gtk depend on -image, since
    Tools.PV requires both but is too small to make its own package
    (Closes: #711060).
  * hurd.patch (new): Make Pike build on Debian GNU/Hurd.

 -- Magnus Holmgren <holmgren@debian.org>  Thu, 06 Jun 2013 22:53:05 +0200

pike7.8 (7.8.700-4) unstable; urgency=low

  * reg_enum_conflict.patch: The conflict is with an enum, so we have to
    rename our enum constants (really Closes: #708366). Also add DEP-3
    header.

 -- Magnus Holmgren <holmgren@debian.org>  Sun, 26 May 2013 21:35:09 +0200

pike7.8 (7.8.700-3) unstable; urgency=low

  * Link pike7.8-odbc to unixodbc, not iodbc, since the latter is not
    multiarch-aware and not capable of handling the ODBC drivers in
    wheezy (Closes: #707911).
  * reg_enum_conflict.patch (new): Undefine conflicting REG_* definitions
    for now (Closes: #708366).

 -- Magnus Holmgren <holmgren@debian.org>  Thu, 23 May 2013 23:10:42 +0200

pike7.8 (7.8.700-2) unstable; urgency=low

  * Upload to unstable.
  * module-layout.patch: Use __REAL_MAJOR__ and __REAL_MINOR__ in
    version-specific include and module paths; __REAL_VERSION__, being a
    float, could allegedly cause trouble.
  * Bump Standards-Version to 3.9.4

 -- Magnus Holmgren <holmgren@debian.org>  Tue, 07 May 2013 23:10:27 +0200

pike7.8 (7.8.700-1) experimental; urgency=low

  * New upstream release.
  * Since the upstream tarball no longer contains Nettle 1.15, which
    contained non-fee IETF documents, but instead Nettle 2.5, we can ship
    it unmodified.
  * Override the Lintian warnings about outdated config.guess files in the
    bundles directories, as they aren't used.
  * Drop nettle-2.1.patch. Refresh remaining patches.
  * Exclude the ZXID module for now, until zxid has been packaged for
    Debian.
  * No longer exclude the PV (picture viewer) tool, as it now supports
    GTK+2.

 -- Magnus Holmgren <holmgren@debian.org>  Sun, 07 Oct 2012 21:54:26 +0200

pike7.8 (7.8.550-dfsg-1) experimental; urgency=low

  * The latest official upstream "beta" release.
    - Dropped dumping_problems.patch; incorporated upstream.
    - unbreak_cross_compilation.patch partially incorporated upstream.
    * Update debian/watch to point to
      http://pike.ida.liu.se/download/pub/pike/beta/.

 -- Magnus Holmgren <holmgren@debian.org>  Mon, 25 Apr 2011 00:28:05 +0200

pike7.8 (7.8.352-dfsg-7) unstable; urgency=low

  * Correct Replaces/Breaks for the move of files in -6 (Closes: #678846).


