=== debian/watch ===
version=3

http://pike.ida.liu.se/download/pub/pike/all/(8\.0\.\d+)/ .*/Pike-v(8\.0\.\d+)\.tar\.xz
